/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api;

import java.util.Collection;
import java.io.Serializable;

public interface JalistoProperties extends Serializable {
    String getName();

    String getProperty(String key);

    Collection getTraceModuleNames();

    String getPropertiesPath();

    int getInitialSize();

    int getOidPageSize();

    int getOidTableSize();

    int getAdditionalSpace();

    int getObjectCacheSize();

    int getPageCacheSize();

    int getMBeanJmxPort();

    double getCacheClearPourcent();

    short getClassPageSize();

    short getSystemPageSize();

    String getImplementation();

    boolean isMonoImplementation();

    boolean isReadOnlyImplementation();

    boolean isMultiImplementation();

    boolean isKeepingInMemory();

    boolean isCleanLog();

    boolean allowsSpecialFunctionnalities();

    short getInstancePageSize();

    int getKeyLength();

    String getCommunicationFactoryClassName();

    String getLogFileName();

    boolean isTraceEnable();

    JalistoProperties getClone();

    String getDbFileFullName();

    String getOidDbFilePath();

    String getSystemDbFilePath();

    int getInstanceDbFileNumber();

    String getInstanceDbFilePathAt(int index);

    Collection getKeys();

    void compareProperties(JalistoProperties oldProps);

    void checkProperty(JalistoProperties oldProps, String property);

    String[] getPathes();

    void setProperty(String key, String property);

    String getServerPropertiesPath();

    String getHost();

    int getPort();

    String getInternalFactoryClass();


    public final static int SYSTEM_INDEX = 0;
    public final static int OID_INDEX = 1;
    public final static int INDEXES_INDEX = 1;

    public final static String MONO_IMPLEMENTATION = "mono";
    public final static String READONLY_IMPLEMENTATION = "readonly";
    public final static String MULTI_IMPLEMENTATION = "multi";
    public final static String REMOTE_IMPLEMENTATION = "remote";


    public final static String NAME_KEY = "name";
    public final static String IMPLEMENTATION_KEY = "userMode";
    public final static String DATABASE_FILES_PATHS_KEY = "dbFilesPaths";
    public final static String DATABASE_INITIAL_SIZE_KEY = "dbInitialSize";
    public final static String CACHE_IMPLEMENTATION_KEY = "cacheClass";
    public final static String OBJECT_CACHE_SIZE_KEY = "objectCacheSize";
    public final static String PAGE_CACHE_SIZE_KEY = "pageCacheSize";
    public final static String CACHE_CLEAR_POURCENT_KEY = "cacheClearPourcent";
    public final static String OIDTABLE_SIZE_KEY = "oidTableSize";
    public final static String OBJECT_INST_PAGE_SIZE_KEY = "instancePageSize";
    public final static String OBJECT_SYST_PAGE_SIZE_KEY = "systemPageSize";
    public final static String OBJECT_CLASS_PAGE_SIZE_KEY = "classPageSize";
    public final static String OBJECT_OID_PAGE_SIZE_KEY = "oidPageSize";
    public final static String CONCURRENCY_MODE_KEY = "concurrencyMode";
    public final static String TIME_OUT_KEY = "timeOut";                    // not documented
    public final static String ADD_SPACE_KEY = "addSpace";                  // not documented
    public final static String INTERNAL_KEY_MAX_SIZE_KEY = "internalKeyMaxSize";    // not documented
    public final static String ALLOWS_SPECIAL_FUNCTIONNALITIES_KEY = "allowsSpecialFunctionnalities";         // not documented
    public final static String PHYSICAL_ACCESS_CLASS_KEY = "physicalClass";
    public final static String INTERNAL_FACTORY_CLASS_KEY = "internalFactoryClass";           // not documented
    public final static String COMMUNICATION_FACTORY_CLASS_KEY = "communicationFactoryClass";
    public final static String QUERY_MANAGER_CLASS_KEY = "queryManagerClass";
    public final static String MBEAN_SERVER_CLASS_KEY = "jalistoMBeanServerClass";            // not documented
    public final static String MBEAN_JMX_SERVER_PORT_KEY = "MBeanHtmlServerPort";             // not documented
    public final static String KEEP_IN_MEMORY_KEY = "keepInMemory";
    public final static String CLEAN_LOG_KEY = "cleanLog";          // not documented
    public final static String LOG_FILE_KEY = "logFile";
    public final static String TRACE_KEY = "trace";
}
