/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.impl.InFileAddress;

import java.util.Collection;
import java.util.Map;

public interface InTransactionBaseImage {
    boolean isWorking();

    void commit();

    void rollback();

    void insertFileObject(InFileAddress ifa, JalistoObject fo);

    JalistoObject readFileObjectAt(InFileAddress ifa);

    void updateFileObject(InFileAddress ifa, JalistoObject fo);

    void deleteFileObject(InFileAddress ifa);

    int getDeletedObjectsSize();

    int getModifiedObjectsSize();

    int getNewObjectsSize();

    Map getReadObjects();

    boolean isKeepInMemory();

    void setKeepInMemory(boolean keepInMemory);

    boolean startWorking();

    void stopWorking();

    Collection getKeysStartingWith(String filter, boolean withOrder);
}
