/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.api.JalistoProperties;
import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.remote.ClientCommunicationAgent;
import org.objectweb.jalisto.se.api.remote.JalistoServer;
import org.objectweb.jalisto.se.api.internal.multi.LockTable;
import org.objectweb.jalisto.se.api.physical.PluggablePhysicalFileAccess;
import org.objectweb.jalisto.se.impl.server.IdentityProvider;
import org.objectweb.jalisto.se.impl.lock.AccessController;
import org.objectweb.jalisto.se.impl.trace.Trace;

import java.util.Map;

public interface InternalFactory {

    void setSelfInstance();

    void init();

    JalistoProperties getProperties(String path);

    Object getSessionId(JalistoProperties properties, Session session);

    InternalMetaRepository getMetaRepository(JalistoProperties properties);

    InternalMetaRepository getMetaRepository(JalistoProperties properties, ClientCommunicationAgent connexion);

    IdentityProvider getIdentityProvider(JalistoProperties properties);

    PluggablePhysicalFileAccess getPhysicalAccess(JalistoProperties properties);

    Trace getTracer(JalistoProperties properties);

    AccessController getAccessController(JalistoProperties properties);

    Session getSession(String propertiesFilePath);

    Session getSession(JalistoProperties properties);

    OidTable getOidTable(JalistoProperties properties);

    InTransactionBaseImage getAInTransactionBaseImage(
            PluggablePhysicalFileAccess physicalAccess, JalistoProperties properties);

    LogicalSystemPageAccess getLogicalAccess(JalistoProperties properties);

    InternalPhysicalFileAccess getInternalPhysicalAccess(JalistoProperties properties);

    LockTable getLockTable(JalistoProperties properties);

    DataWrapper getNewDataWrapper(JalistoProperties properties, Object[] arrayOfObjects);

    Map getCache(JalistoProperties properties, int size, String name);

    Object getSessionById(Object sessionId);

    void launchMBeanHtmlServer(JalistoProperties props);

    void cleanFactory();

    ClientCommunicationAgent getClientCommunicationAgent(JalistoProperties properties);

    JalistoServer getJalistoServer(String communicationFactoryClassName);

}
