/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.impl.server.PhysicalOid;
import org.objectweb.jalisto.se.impl.InFileAddress;
import org.objectweb.jalisto.se.api.query.FieldDescription;

public interface LogicalSystemPageAccess {

    void insertDatas(Object sessionId, PhysicalOid fpoid, DataWrapper datas);

    DataWrapper readDatas(Object sessionId, PhysicalOid fpoid);

    PhysicalOid updateDatas(Object sessionId, PhysicalOid fpoid, DataWrapper datas);

    void deleteDatas(Object sessionId, PhysicalOid fpoid);


    PhysicalOid allocateNewFpoid(Object sessionId, Object clid);

    void desallocateFpoid(Object sessionId, PhysicalOid fpoid);


    InFileAddress allocateLeafAddressAndInsert(Object sessionId, FieldDescription meta, DataWrapper oids);

    Object readLeaf(Object sessionId, InFileAddress ifa);

    void updateLeaf(Object sessionId, InFileAddress ifa, DataWrapper oids);

    void removeLeaf(Object sessionId, InFileAddress ifa);

    InFileAddress allocateNodeAddressAndInsert(Object sessionId, FieldDescription meta, DataWrapper node);

    Object readNode(Object sessionId, InFileAddress ifa);

    void updateNode(Object sessionId, InFileAddress ifa, DataWrapper node);

    void removeNode(Object sessionId, InFileAddress ifa);


    void begin(Object sessionId);

    void commit(Object sessionId);

    void rollback(Object sessionId);


    public void cleanAllNullValue();

    InternalPhysicalFileAccess getPhysicalAccess();
}
