/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.impl.server.oid.*;

import java.util.Map;

public interface OidActionCaller {

    void callCommitAction(OidTableCallback oidTable, LogicalOid floid, OidInfo info, Map map);

    boolean isDelete();

    boolean isInsert();

    public static final OidActionCaller INSERT_CALLER = new OidActionCallerInsert();
    public static final OidActionCaller UPDATE_CALLER = new OidActionCallerUpdate();
    public static final OidActionCaller DELETE_CALLER = new OidActionCallerDelete();
    public static final OidActionCaller READ_CALLER = new OidActionCallerRead();
}
