/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.impl.*;
import org.objectweb.jalisto.se.impl.server.IdentityProvider;
import org.objectweb.jalisto.se.impl.server.PhysicalOid;

import java.util.Collection;

public interface OidTable {
    LogicalOid allocateNewFloid(short clid);

    Collection getFloidsFromClid(Object sessionId, Object clid, boolean fullyTransactionnal);

    Collection getFloidsFromClid(Object sessionId, Object clid, ExtentImpl extent, int number);

    PhysicalOid getFpoid(Object sessionId, LogicalOid floid);

    void markAsCreated(Object sessionId, LogicalOid floid);

    boolean containsFloid(Object sessionId, LogicalOid floid);

    PhysicalOid getDeletedFpoid(Object sessionId, LogicalOid floid);

    void setUpdate(Object sessionId, LogicalOid floid, short value);

    short getUpdate(Object sessionId, LogicalOid floid, boolean transactionnal);

    void insertFpoid(Object sessionId, LogicalOid floid, PhysicalOid fpoid);

    void removeFloid(Object sessionId, LogicalOid floid);

    void updatePoid(Object sessionId, LogicalOid floid, PhysicalOid newFpoid);

    void begin(Object sessionId);

    void commit(Object sessionId);

    void rollback(Object sessionId);

    void open(Object sessionId);

    void close(Object sessionId);

    IdentityProvider getIdentityProvider();
}
