/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.api.internal.multi;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.api.internal.DataWrapper;

import java.util.Collection;

public interface LockManager {
    void setLockTable(org.objectweb.jalisto.se.api.internal.multi.LockTable lockTable);

    DataWrapper getLockedValue(LogicalOid floid, Object sessionId);

    void setLockedValue(LogicalOid floid, Object sessionId, DataWrapper value, short update);

    short getUpdate(LogicalOid floid, Object sessionId);

    void setSession(SessionMulti session);

    void begin();

    void checkLocksForSession(Collection floids, Object sessionId);

    void commit();

    boolean containsDeletedValue(LogicalOid floid, Object sessionId);

    boolean containsLockedValue(LogicalOid floid, Object sessionId);

    void finishCreateObject(LogicalOid floid, DataWrapper objectToCreate);

    void finishDeleteObjectByOid(LogicalOid floid);

    void finishMakeNewFileOid(LogicalOid floid);

    void finishReadObjectByOid(LogicalOid floid, DataWrapper objectToRead, short update);

    void finishUpdateObjectByOid(LogicalOid floid, DataWrapper objectToUpdate, short update);

    void prepareCreateObject(LogicalOid floid, DataWrapper objectToCreate);

    void prepareDeleteObjectByOid(LogicalOid floid, short update);

    void prepareReadObjectByOid(LogicalOid floid);

    void rollback();
}
