/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.exception;

import java.io.PrintStream;
import java.io.PrintWriter;

public class JalistoException extends RuntimeException {
    public JalistoException() {
        this.message = "";
        this.cause = null;
    }

    public JalistoException(String s) {
        this.message = s;
        this.cause = null;
    }

    public JalistoException(Throwable t) {
        this.message = "";
        this.cause = t;
    }

    public JalistoException(String s, Throwable t) {
        this.message = s;
        this.cause = t;
    }


    public void printStackTrace() {
        System.err.println("JalistoException : "+String.valueOf(message)+"\n");
        if (cause != null) {
            System.err.println("internal exception : \n");
            cause.printStackTrace();
        }
    }

    public void printStackTrace(PrintStream s) {
        s.println("JalistoException : "+String.valueOf(message)+"\n");
        if (cause != null) {
            s.println("internal exception : \n");
            cause.printStackTrace(s);
        }
    }

    public void printStackTrace(PrintWriter s) {
        s.println("JalistoException : "+String.valueOf(message)+"\n");
        if (cause != null) {
            s.println("internal exception : \n");
            cause.printStackTrace(s);
        }
    }

    public StackTraceElement[] getStackTrace() {
        return cause.getStackTrace();
    }

    public void setStackTrace(StackTraceElement[] stackTrace) {
        cause.setStackTrace(stackTrace);
    }

    public String getLocalizedMessage() {
        return message;
    }

    public String getMessage() {
        return message;
    }

    public String toString() {
        return "JalistoException : "+String.valueOf(message);
    }

    public synchronized Throwable fillInStackTrace() {
        return super.fillInStackTrace();
    }

    public Throwable getCause() {
        return cause;
    }

    private String message;
    private Throwable cause;
}
