/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl;

import java.io.Serializable;

public class InFileAddress implements Serializable {

    public InFileAddress(String address) {
        this.address = address;
        index = 0;
        fileIndex = 0;
    }

    public String getAddress() {
        return address;
    }

    public InFileAddress getClone() {
        InFileAddress result = new InFileAddress(address);
        result.setIndex(index);
        result.setFileIndex(fileIndex);
        return result;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public void setFileIndex(int fileIndex) {
        this.fileIndex = fileIndex;
    }

    public int getFileIndex() {
        return fileIndex;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public int getIndex() {
        return index;
    }

    public void incrementeFileIndex() {
        index++;
    }

    public boolean equals(Object obj) {
        try {
            InFileAddress candidate = (InFileAddress) obj;
            return ((candidate.address.equals(this.address)) && (candidate.index == this.index));
        } catch (Exception e) {
        }
        return false;
    }

    public int hashCode() {
        return ((index * 100000) + address.hashCode());
    }

    public String toString() {
        return "ifa(" + String.valueOf(address) + "," + String.valueOf(fileIndex) + "," + String.valueOf(index) + ")";
    }


    // the physical address of the JalistoObject wrapper
    private String address;
    // the index of underlying physical file
    private int fileIndex;
    // the index of the data in the page
    private int index;


    static final long serialVersionUID = -7589377069064761459L;
}
