/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.cache;

import java.util.ArrayList;

public class CacheCell {

    private CacheCell() {
        instanceCounter++;
    }

    private void init(Object id, Object object) {
        this.object = object;
        this.id = id;
    }

    public Object getId() {
        return id;
    }

    public void setObject(Object newObject) {
        object = newObject;
    }

    public Object getObject() {
        return object;
    }

    public void setPrecedingCell(CacheCell cell) {
        precedingCell = cell;
    }

    public CacheCell getPrecedingCell() {
        return precedingCell;
    }

    public void setNextCell(CacheCell cell) {
        nextCell = cell;
    }

    public CacheCell getNextCell() {
        return nextCell;
    }

    public void delink() {
        if (nextCell != null) {
            nextCell.setPrecedingCell(precedingCell);
        }
        if (precedingCell != null) {
            precedingCell.setNextCell(nextCell);
        }
        nextCell = null;
        precedingCell = null;
        id = null;
        object = null;
        if (c.size() < 0) {
            c.add(this);
        }
    }

    public int hashCode() {
        return id.hashCode();
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("CC(").append(id).append(",").append(object).append(")");
        return sb.toString();
    }

    private CacheCell precedingCell;
    private CacheCell nextCell;
    private Object id;
    private Object object;


    public static CacheCell newInstance(Object id, Object object) {
        CacheCell newObject;
        if (c.isEmpty()) {
            newObject = new CacheCell();
        } else {
            newObject = (CacheCell) c.remove(0);
        }
        newObject.init(id, object);
        return newObject;
    }

    private static ArrayList c = new ArrayList();
    public static int instanceCounter = 0;
}