/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.lock;

public class AccessController {
    public AccessController() {
        canGetAccess = new boolean[2];
        canGetAccess[NEW_OID] = true;
        canGetAccess[COMMIT_ROLLBACK_LOCKMANAGER] = true;
    }

    public void getAccessControl(int accessIndex) {
        while (!getAccess(accessIndex)) {
            Thread.yield();
        }
    }

    private synchronized boolean getAccess(int accessIndex) {
        if (!canGetAccess[accessIndex]) {
            return false;
        }
        canGetAccess[accessIndex] = false;
        return true;
    }

    public synchronized void releaseAccessControl(int accessIndex) {
        canGetAccess[accessIndex] = true;
    }

    private boolean[] canGetAccess;

    public final static int NEW_OID = 0;
    public final static int COMMIT_ROLLBACK_LOCKMANAGER = 1;
}
