/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server;

import org.objectweb.jalisto.se.api.internal.DataWrapper;
import org.objectweb.jalisto.se.impl.InFileAddress;

public class DataWrapperImpl implements DataWrapper {
    protected Object[] datas;

    public DataWrapperImpl() {
    }

    public void init(Object[] theDatas) {
        datas = new Object[theDatas.length];
        System.arraycopy(theDatas, 0, datas, 0, theDatas.length);
    }

    public DataWrapper getClone() {
        if (datas == null) {
            return this;
        }
        return newInstance(datas);
    }

    public void setDatas(Object[] newDatas) {
        if (newDatas.length != datas.length) {
            datas = new Object[newDatas.length];
        }
        System.arraycopy(newDatas, 0, datas, 0, newDatas.length);
    }

    public Object[] getDatas() {
        Object[] result = new Object[datas.length];
        System.arraycopy(datas, 0, result, 0, datas.length);
        return result;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("[");
        for (int i = 0; i < datas.length; i++) {
            if (datas[i] == null) {
                sb.append("null");
            } else {
                sb.append(datas[i]);
            }
            if (i != (datas.length - 1)) {
                sb.append(";");
            }
        }
        sb.append(']');
        return sb.toString();
    }

    public InFileAddress getIfa() {
        return null;
    }

    public void setIfa(InFileAddress ifa) {
    }

    public static DataWrapperImpl newInstance(Object[] theDatas) {
        DataWrapperImpl newObject = new DataWrapperImpl();
        newObject.init(theDatas);
        return newObject;
    }


    static final long serialVersionUID = -7589377097911761459L;
}
