/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server;

import org.objectweb.jalisto.se.api.internal.JalistoObject;
import org.objectweb.jalisto.se.impl.InFileAddress;

public class JalistoObjectImpl implements JalistoObject, Cloneable {
    private transient InFileAddress ifa;
    private Object data;

    public JalistoObjectImpl() {
    }

    public void setData(Object data) {
        this.data = data;
    }

    public Object getData() {
        return data;
    }

    public void setIfa(InFileAddress ifa) {
        this.ifa = ifa.getClone();
    }

    public InFileAddress getIfa() {
        return ifa;
    }

    public JalistoObject getClone() {
        JalistoObject clone = new JalistoObjectImpl();
        clone.setIfa(ifa.getClone());
        clone.setData(data);
        return clone;
    }

    public String toString() {
        if (data != null) {
            if (data instanceof Object[]) {
                Object[] storedDatas = (Object[]) data;
                StringBuffer sb = new StringBuffer();
                sb.append("JalistoObjectImpl[");
                for (int i = 0; i < storedDatas.length; i++) {
                    if (storedDatas[i] == null) {
                        sb.append("null");
                    } else {
                        sb.append(storedDatas[i]);
                    }
                    if (i != (storedDatas.length - 1)) {
                        sb.append(";");
                    }
                }
                sb.append("]");
                return sb.toString();
            } else {
                return "JalistoObjectImpl[" + data.toString() + "]";
            }
        } else {
            return "JalistoObjectImpl[" + super.toString() + "]";
        }
    }


    static final long serialVersionUID = -7589388097964761459L;
}
