/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server;

import java.io.Serializable;
import java.util.StringTokenizer;

public class PhysicalOid implements Serializable {

    public PhysicalOid() {
    }

    public PhysicalOid(Object clid, Object pid, Object iid) {
        this.clid = ((Number) clid).shortValue();
        this.pid = ((Number) pid).intValue();
        this.iid = ((Number) iid).shortValue();
    }

    public PhysicalOid(String fpoidAsString) {
        StringTokenizer st = new StringTokenizer(fpoidAsString, ":");
        this.clid = Short.parseShort(st.nextToken());
        this.pid = Integer.parseInt(st.nextToken());
        this.iid = Short.parseShort(st.nextToken());
    }

    public Object getClid() {
        return new Short(clid);
    }

    public Object getIid() {
        return new Short(iid);
    }

    public Integer getIidAsInteger() {
        return new Integer(iid);
    }

    public Object getPid() {
        return new Integer(pid);
    }

    public boolean equals(Object obj) {
        try {
            PhysicalOid candidate = (PhysicalOid) obj;

            return ((candidate.clid == this.clid) &&
                    (candidate.pid == this.pid) && (candidate.iid == this.iid));
        } catch (Exception e) {
        }

        return false;
    }

    public boolean hasClidEqualsWith(Object candidateClid) {
        try {
            return ((Short) candidateClid).shortValue() == this.clid;
        } catch (Exception e) {
        }

        return false;
    }

    public int hashCode() {
        int result = Integer.parseInt(String.valueOf(clid) +
                                      String.valueOf(pid) +
                                      String.valueOf(iid));

        return result;
    }

    public PhysicalOid getClone() {
        PhysicalOid clone = new PhysicalOid();
        clone.clid = clid;
        clone.iid = iid;
        clone.pid = pid;
        return clone;
    }

    public String toString() {
        return String.valueOf(clid) + ":" + String.valueOf(pid) + ":" +
               String.valueOf(iid);
    }


    private short clid;  // classe identity
    private short iid;   // instance identity
    private int pid;   // page identity


    static final long serialVersionUID = -7589366669041161459L;
}