/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server.oid;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.exception.IdentityException;
import org.objectweb.jalisto.se.impl.server.PhysicalOid;
import org.objectweb.jalisto.se.api.internal.OidActionCaller;

import java.io.Serializable;

public class OidInfo implements Serializable {

    public OidInfo(LogicalOid floid, PhysicalOid fpoid) {
        this.floid = floid;
        this.fpoid = fpoid;
        this.update = 0;
        this.created = false;
    }

    public OidInfo(LogicalOid floid, PhysicalOid fpoid, short update) {
        this.floid = floid;
        this.fpoid = fpoid;
        this.update = update;
    }

    public boolean isDeleting() {
        return (fpoid == null);
    }

    public LogicalOid getFloid() {
        return floid;
    }

    public void setFpoid(PhysicalOid fpoid) {
        this.fpoid = fpoid;
    }

    public PhysicalOid getFpoid() {
        return fpoid;
    }

    public void setUpdate(short update) {
        this.update = update;
    }

    public short getUpdate() {
        return update;
    }

    public boolean isCreated() {
        return created;
    }

    public void markAsCreated() {
        if (created) {
            throw new IdentityException("the given oid " + floid + " already has created datas");
        }
        created = true;
    }

    public OidActionCaller getActionCaller() {
        return actionCaller;
    }

    public void setActionCaller(OidActionCaller actionCaller) {
        this.actionCaller = actionCaller;
    }

    public OidInfo getClone() {
        OidInfo clone = new OidInfo(floid.getClone(), fpoid.getClone());
        clone.setUpdate(update);
        return clone;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("oidi").append(actionCaller).append("(").append(floid).append(',').append(fpoid).append(',').append(
                update).append(")");
        return sb.toString();
    }


    private LogicalOid floid;
    private PhysicalOid fpoid;
    private short update;
    private boolean created;
    private transient OidActionCaller actionCaller = OidActionCaller.READ_CALLER;

    static final long serialVersionUID = -7589377044064761459L;
}
