/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server.page.info;

import org.objectweb.jalisto.se.impl.InFileAddress;

import java.util.ArrayList;

public class InMemoryPageInfo {

    protected InMemoryPageInfo(PageInfo pageInfo) {
        ifa = pageInfo.getPageIfa();
        freeSpaceSize = pageInfo.getEmptySpace();
        transactionalImage = -1;
        pid = pageInfo.getPid();
    }

    public void getAFreeSpace(Object sessionId) {
        freeSpaceSize--;
    }

    public void freeASpace(Object sessionId) {
        freeSpaceSize++;
    }

    public int getFreeSpaceSize() {
        return freeSpaceSize;
    }

    public InFileAddress getInstancePageIfa() {
        return ifa;
    }

    public Object getPid() {
        return pid;
    }

    public String toString() {
        return "IMPO:" + freeSpaceSize + "@" + ifa.getAddress();
    }

    public void begin(Object sessionId) {
        transactionalImage = freeSpaceSize;
    }

    public boolean rollback(Object sessionId) {
        if (transactionalImage < 0) {
            return false;
        }
        freeSpaceSize = transactionalImage;
        return true;
    }

    private InFileAddress ifa;
    protected int freeSpaceSize;
    private int transactionalImage;
    private Object pid;


    public static InMemoryPageInfo createNewInstance(ArrayList sessionIds, boolean isMonoImplementation,
                                                     PageInfo pageInfo) {
        if (isMonoImplementation) {
            return new InMemoryPageInfo(pageInfo);
        } else {
            return new InMemoryPageInfoMulti(sessionIds, pageInfo);
        }
    }
}
