/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.server.page.info;

import org.objectweb.jalisto.se.impl.server.page.info.InMemoryPageInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class InMemoryPageInfoMulti extends InMemoryPageInfo {

    protected InMemoryPageInfoMulti(ArrayList sessionIds, PageInfo pageInfo) {
        super(pageInfo);
        transactionnalImage = new HashMap();
        if (sessionIds != null) {
            for (int i = 0; i < sessionIds.size(); i++) {
                begin(sessionIds.get(i));
            }
        }
    }

    public void getAFreeSpace(Object sessionId) {
        freeSpaceSize--;
        Integer i = (Integer) transactionnalImage.get(sessionId);
        transactionnalImage.put(sessionId, new Integer(i.intValue() + 1));
    }

    public void freeASpace(Object sessionId) {
        freeSpaceSize++;
        Integer i = (Integer) transactionnalImage.get(sessionId);
        transactionnalImage.put(sessionId, new Integer(i.intValue() - 1));
    }

    public void begin(Object sessionId) {
        transactionnalImage.put(sessionId, new Integer(0));
    }

    public boolean rollback(Object sessionId) {
        int i = ((Integer) transactionnalImage.get(sessionId)).intValue();
        if (i < 0) {
            return false;
        }
//        freeSpaceSize = freeSpaceSize + i;
        if (i != 0) {
//            System.out.println("InMemoryPageInfoMulti rollback "+i+" -> 0");
            transactionnalImage.put(sessionId, new Integer(0));
        }
        return true;
    }

    private Map transactionnalImage;
}
