/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.impl.trace;

import java.util.Collection;
import java.util.HashSet;

public class TraceContext {
    private HashSet moduleNames;
    private boolean isEnable;
    private Trace tracer;

    public TraceContext(boolean enable, Collection moduleNamesToAdd) {
        isEnable = enable;
        moduleNames = new HashSet(moduleNamesToAdd);
        if (isEnable) {
            moduleNames.add("TRACE");
        }
    }

    public boolean isTracing(Trace.Module component) {
        return (isEnable && moduleNames.contains(component.getName()));
    }

    public Trace getTracer() {
        if (tracer == null) {
            if (moduleNames.isEmpty()) {
                tracer = new TraceNull();
            } else {
                tracer = new TraceErr(this);
                tracer.enableTrace(isEnable);
                tracer.init(moduleNames.iterator());
            }
        }
        return tracer;
    }
}
