/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf;

import java.io.*;
import java.util.ArrayList;

public class DbByteArrayOutputStream extends ByteArrayOutputStream {
    private DbByteArrayOutputStream() {
        super();
        output = new DataOutputStream(this);
    }

    public synchronized void writeTo(DataOutput dstr) throws IOException {
        dstr.write(super.buf, 0, super.size());
    }

    public void writeDatas(byte[] datas) {
        if (super.buf.length < datas.length) {
            super.buf = datas;
        } else {
            System.arraycopy(datas, 0, super.buf, 0, datas.length);
        }
        super.count = datas.length;
    }

    public byte[] getDataToWrite() {
        return super.buf;
    }

    public synchronized void reset() {
        super.reset();
        instances.add(this);
    }

    public DataOutputStream getOutput() {
        return output;
    }

    private DataOutputStream output;

    /** ***********************************     STATIC    **************************************************** */

    private static ArrayList instances = new ArrayList();

    public static DbByteArrayOutputStream getInstance() {
        if (instances.isEmpty()) {
            return new DbByteArrayOutputStream();
        }
        try {
            return (DbByteArrayOutputStream) instances.remove(0);
        } catch (ArrayIndexOutOfBoundsException e) {
            return new DbByteArrayOutputStream();
        }
    }
}
