/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf.log.backup;

import java.io.*;

public class LogBoundary extends LogObject {

    public LogBoundary(boolean begin) {
        isBegin = begin;
    }

    public boolean isBegin() {
        return isBegin;
    }

    public boolean isEnd() {
        return (!isBegin);
    }

    public Object internalReadFrom(DataInput in) throws IOException {
        return null;
    }

    public void writeTo(DataOutput out) throws IOException {
        LogObject.writeLogBoundary(out, isBegin);
    }

    public void undoOn(RandomAccessFile raf) throws IOException {
    }

    public void corrupt(RandomAccessFile raf) throws IOException {
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("LogBoundary(");
        if (isBegin) {
            sb.append("begin");
        } else {
            sb.append("end");
        }
        sb.append(")");
        return sb.toString();
    }

    private boolean isBegin;

    static final long serialVersionUID = -7699636669241161459L;
}
