/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.storage.raf.log.synraf.viewer;


import org.objectweb.jalisto.se.api.JalistoProperties;
import org.objectweb.jalisto.se.impl.JalistoPropertiesImpl;
import org.objectweb.jalisto.se.storage.raf.log.synraf.action.LogAction;

import java.io.PrintWriter;
import java.io.RandomAccessFile;

public class TransactionLogInspector {
    public void inspectRecordsFile(PrintWriter out, RandomAccessFile raf, long at)
            throws Exception {

        raf.seek(at);

        while (raf.getFilePointer() < raf.length()) {
            LogAction logAction = new LogAction();
            logAction.readFrom(raf);
            System.out.println(String.valueOf(logAction));
        }
    }

    public static void main(String[] args) {
        try {
            JalistoProperties prop;
            if (args.length < 1) {
                prop = new JalistoPropertiesImpl("");
            } else {
                prop = new JalistoPropertiesImpl(args[0]);
            }

            long at = 0;
            if (args.length > 1) {
                at = Long.parseLong(args[1]);
            }

            RandomAccessFile raf = new RandomAccessFile(prop.getLogFileName(), "r");
            PrintWriter out = new PrintWriter(System.out);
            (new TransactionLogInspector()).inspectRecordsFile(out, raf, at);
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
