/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.test.data;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.JalistoFactory;
import org.objectweb.jalisto.se.impl.meta.type.MetaTypeFactory;

import java.io.Serializable;

public class DVD implements Serializable {
    private DVD() {
    }

    private DVD(String title, int price, String author) {
        this.title = title;
        this.price = price;
        this.director = author;
    }

    public String getDirector() {
        return director;
    }

    public void setDirector(String director) {
        this.director = director;
    }

    public int getPrice() {
        return price;
    }

    public void setPrice(int price) {
        this.price = price;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public static DVD newDVD() {
        counter++;
        return new DVD(getNewTitle(counter),
                       getNewPrice(counter),
                       getNewDirector(counter));
    }

    public Object[] toArray() {
        Object[] result = new Object[3];
        result[0] = title;
        result[1] = new Integer(price);
        result[2] = director;
        return result;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("'").append(title);
        sb.append("from ").append(director).append(", ");
        sb.append(price).append(" E");
        sb.append("'");
        return sb.toString();
    }

    public static DVD toDVD(Object[] array) {
        DVD dvd = new DVD();
        dvd.setTitle((String) array[0]);
        dvd.setPrice(((Integer) array[1]).intValue());
        dvd.setDirector((String) array[2]);
        return dvd;
    }

    public static ClassDescription getMetaDescription() {
        ClassDescription meta = JalistoFactory.createClassDescription(DVD.class.getName());
        meta.addField(JalistoFactory.createFieldDescription("title", MetaTypeFactory.StringType));
        meta.addField(JalistoFactory.createFieldDescription("price", MetaTypeFactory.IntegerType));
        meta.addField(JalistoFactory.createFieldDescription("director", MetaTypeFactory.StringType));
        meta.setLeafPageSize(0, (short) 3);
        meta.setNodePageSize(0, (short) 2);
        meta.setNodeSize(0, (short) 4);
        return meta;
    }

    private static String getNewTitle(int c) {
        return titles[c % titles.length];
    }

    private static String getNewDirector(int c) {
        return directors[c % directors.length];
    }

    private static int getNewPrice(int c) {
        return prices[c % prices.length];
    }

    private String title;
    private int price;
    private String director;

    public static int counter = -1;
    public static final String[] titles = {"The Pianist",
                                           "The Right Stuff",
                                           "Dr. Quinn Medicine Woman",
                                           "Throne of Blood",
                                           "About Schmidt",
                                           "A Guy Thing",
                                           "Sex and the City",
                                           "Miller's Crossing",
                                           "The Animatrix",
                                           "Dark Blue"};
    public static final int[] prices = {5,
                                        10,
                                        15,
                                        20,
                                        25,
                                        30};
    public static final String[] directors = {"Roman Polanski",
                                              "Toshiro Mifune",
                                              "Luc Besson",
                                              "Kevin Costner"};

    static final long serialVersionUID = -7589377099514765159L;
}
