/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.test.data;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.JalistoFactory;
import org.objectweb.jalisto.se.impl.meta.type.MetaTypeFactory;

import java.util.ArrayList;

public class Library {

    private Library(String address, ArrayList clients, ArrayList books) {
        this.address = address;
        this.clients = clients;
        this.books = books;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public ArrayList getBooks() {
        return books;
    }

    public void setBooks(ArrayList books) {
        this.books = books;
    }

    public ArrayList getClients() {
        return clients;
    }

    public void setClients(ArrayList clients) {
        this.clients = clients;
    }

    public Object getAuthorMostWanted() {
        return authorMostWanted;
    }

    public void setAuthorMostWanted(Object authorMostWantedOid) {
        this.authorMostWanted = authorMostWantedOid;
    }


    public Object[] toArray() {
        Object[] result = new Object[4];
        result[0] = address;
        result[1] = clients;
        result[2] = books;
        result[3] = authorMostWanted;
        return result;
    }

    public static Library toLibrary(Object[] array) {
        Library library = new Library(
                (String) array[0],
                (ArrayList) array[1],
                (ArrayList) array[2]);
        library.setAuthorMostWanted(array[3]);
        return library;
    }


    private String address;
    private ArrayList clients;
    private ArrayList books;
    private Object authorMostWanted;


    public static Library newLibrary() {
        counter++;
        return new Library(getNewAddress(counter),
                           new ArrayList(),
                           new ArrayList());
    }

    private static String getNewAddress(int c) {
        return addresses[c % addresses.length];
    }

    public static ClassDescription getMetaDescription() {
        ClassDescription meta = JalistoFactory.createClassDescription(Library.class.getName());
        meta.addField(JalistoFactory.createFieldDescription("address", MetaTypeFactory.StringType));
        meta.addField(JalistoFactory.createFieldDescription("clients", MetaTypeFactory.CollectionType));
        meta.addField(JalistoFactory.createFieldDescription("books", MetaTypeFactory.CollectionType));
        meta.addField(JalistoFactory.createFieldDescription("authorMostWanted", MetaTypeFactory.LinkType));
        return meta;
    }

    public static int counter = -1;
    public static final String[] addresses = {"36 rue de picpus",
                                              "107 rue de reuilly",
                                              "20 rue de dante",
                                              "15 impasse de l'enfer"};

    static final long serialVersionUID = -7589377092222761459L;
}
