/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.test.core.remote.other;

import org.objectweb.jalisto.se.test.data.Book;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.HashMap;
import java.util.Map;

public class TestClient {

    public void run() {
        try {
            connect();
            Thread.sleep(1000);
            System.out.println("start sending messages");
            for (int i = 0; i < 10; i++) {
                toServer.writeObject("pouet" + i);
                toServer.flush();
                waitReply();
                toServer.writeObject(Book.newBook());
                toServer.flush();
                waitReply();
            }
            {
                Map map = new HashMap();
                map.put("tralala1", "pouettralala1");
                map.put("trilili1", "pouettrilili1");
                map.put("trololo1", "pouettrololo1");
                toServer.writeObject(map);
                toServer.flush();
                waitReply();
            }
            {
                Map map = new HashMap();
                map.put("tralala2", "pouettralala2");
                map.put("trilili2", "pouettrilili2");
                map.put("trololo2", "pouettrololo2");
                toServer.writeObject(map);
                toServer.flush();
                waitReply();
            }
            Map map = new HashMap();
            {
                map.put("tralala3", "pouettralala3");
                map.put("trilili3", "pouettrilili3");
                map.put("trololo3", "pouettrololo3");
                toServer.writeObject(map);
                toServer.flush();
                waitReply();
            }
            {
                map.clear();
                map.put("tralala4", "pouettralala4");
                map.put("trilili4", "pouettrilili4");
                map.put("trololo4", "pouettrololo4");
                toServer.writeObject(map);
                toServer.flush();
                waitReply();
            }
            System.out.println("messages sended");
        } catch (IOException ioe) {
            ioe.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            disconnect();
        }
    }

    public void waitReply() throws ClassNotFoundException, IOException {
        Object reply = null;
        while (true) {
            while (reply == null) {
                reply = fromServer.readObject();
            }
            if (reply.equals("ok")) {
                System.out.println("receive reply : " + reply.toString());
                return;
            }
        }
    }

    public void connect() throws IOException {
        socket = new Socket(serverHost, serverPort);
        toServer = new ObjectOutputStream(socket.getOutputStream());
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {
        }
        fromServer = new ObjectInputStream(socket.getInputStream());
    }

    public void disconnect() {
        try {
            socket.close();
            fromServer = null;
            toServer = null;
        } catch (IOException e) {
        }
    }

    public static void main(String[] args) {
        TestClient client = new TestClient();
        client.run();
    }

    private String serverHost = "hecate";
    private int serverPort = 6000;

    private Socket socket;
    private ObjectInputStream fromServer;
    private ObjectOutputStream toServer;

}
