/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.jca.data;

import org.objectweb.jalisto.se.jca.JalistoConnectionSpec;

import javax.resource.cci.ConnectionSpec;
import javax.resource.spi.ConnectionRequestInfo;

public class JalistoConnectionRequestInfo implements ConnectionRequestInfo {
    private Object password = "";
    private Object userName = "";

    public JalistoConnectionRequestInfo(ConnectionSpec spec) {
        if (spec != null) {
            try {
                JalistoConnectionSpec jdoSpec = (JalistoConnectionSpec) spec;
                userName = jdoSpec.getUserName();
                password = jdoSpec.getPassword();
            } catch (ClassCastException cce) {
            }
        }
    }

    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (obj instanceof JalistoConnectionRequestInfo) {
            JalistoConnectionRequestInfo candidate = (JalistoConnectionRequestInfo) obj;
            return (this.userName.equals(candidate.userName) && this.password.equals(candidate.password));
        }
        return false;
    }

    public int hashCode() {
        return super.hashCode();
    }

    public String toString() {
        return "JalistoConnectionRequestInfo : username=" +
               String.valueOf(userName) + ", password=" +
               String.valueOf(password);
    }
}
