/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.jmx;

import org.objectweb.jalisto.se.api.jmx.JalistoMBeanServer;
import org.objectweb.jalisto.se.jmx.exception.MBeanAdminException;

public class JalistoMbeanServerFactory implements JalistoMBeanServer {

    public JalistoMbeanServerFactory() {
    }

    public void addSession(String s) {
        instance.addSession(s);
    }

    public void init(String propertiesPath) {
        try {
            if (instance == null) {
                String className = "org.objectweb.jalisto.se.jmx.server.mx4j.JalistoMbeanServerMx4jImpl";
                instance = (JalistoMBeanServer) Class.forName(className).newInstance();
            }
        } catch (Exception e) {
             throw new MBeanAdminException("could not instanciate any MBean JalistoServer implementation", e);
        }
        instance.init(propertiesPath);
    }

    public boolean isAlive() {
        return instance.isAlive();
    }

    public void run() {
        instance.run();
    }

    JalistoMBeanServer instance;
}
