/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query;

import org.objectweb.jalisto.se.api.ClassDescription;
import org.objectweb.jalisto.se.api.query.FielComparator;
import org.objectweb.jalisto.se.api.query.Index;
import org.objectweb.jalisto.se.api.query.IndexManager;
import org.objectweb.jalisto.se.impl.InFileAddress;
import org.objectweb.jalisto.se.impl.meta.ClassDescriptionImpl;

public class NavigationInfo {

    public NavigationInfo(ClassDescription meta, String[] fieldNames) {
        this.index = meta.getIndex(fieldNames[0]);
        this.meta = (ClassDescriptionImpl) meta;
    }

    public int getIndex() {
        return index;
    }

    public ClassDescription getMeta() {
        return meta;
    }

    public FielComparator getComparator() {
        return meta.getComparator(index);
    }

    public boolean isIndexDefined() {
        return meta.isIndexDefined(index);
    }

    public InFileAddress getIndexIfa() {
        return meta.getIndexIfa(index);
    }

    public Index getIndex(IndexManager indexManager) {
        return indexManager.getIndex(meta, index);
    }

    private int index;
    private ClassDescriptionImpl meta;
}
