/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.btree;

import org.objectweb.jalisto.se.impl.LogicalOid;
import org.objectweb.jalisto.se.impl.InFileAddress;
import org.objectweb.jalisto.se.impl.server.DataWrapperImpl;

import java.util.HashSet;
import java.util.Set;

public class OidCollection extends DataWrapperImpl {
    public OidCollection() {
        oids = new HashSet();
    }

    public void addOid(LogicalOid floid) {
        oids.add(floid);
    }

    public void removeOid(LogicalOid floid) {
        oids.remove(floid);
    }

    public boolean isEmpty() {
        return oids.isEmpty();
    }

    public Set asSet() {
        return new HashSet(oids);
    }

    public InFileAddress getIfa() {
        return ifa;
    }

    public void setIfa(InFileAddress inFileAddress) {
        this.ifa = inFileAddress;
    }

    public String toString() {
        return "OidCollection(" + oids.size() + ")";
    }

    public String toFullString() {
        StringBuffer sb = new StringBuffer();
        sb.append("OidCollection(");
        sb.append("size:").append(oids.size()).append(",").append(oids).append(")");
        return sb.toString();
    }

    private Set oids;
    private InFileAddress ifa;
}
