/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.constraint;

import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.query.FielComparator;
import org.objectweb.jalisto.se.api.query.Constraint;
import org.objectweb.jalisto.se.query.exception.QueryEngineException;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class ConstraintImpl implements Constraint {
    public ConstraintImpl() {
        this.fathers = new HashSet();
    }

    public Constraint and(Constraint with) {
        BinaryBooleanOperatorConstraint binaryConstraint =
                new BinaryBooleanOperatorConstraint(this, with, BinaryBooleanOperatorConstraint.AND_OP);
        fathers.add(binaryConstraint);
        ((ConstraintImpl) with).addBinaryConstraint(binaryConstraint);
        return binaryConstraint;
    }

    public Constraint or(Constraint with) {
        BinaryBooleanOperatorConstraint binaryConstraint =
                new BinaryBooleanOperatorConstraint(this, with, BinaryBooleanOperatorConstraint.OR_OP);
        fathers.add(binaryConstraint);
        ((ConstraintImpl) with).addBinaryConstraint(binaryConstraint);
        return binaryConstraint;
    }

    public Constraint equal() {
        throw new QueryEngineException();
    }

    public Constraint greater() {
        throw new QueryEngineException();
    }

    public Constraint smaller() {
        throw new QueryEngineException();
    }

    public Constraint identity() {
        throw new QueryEngineException();
    }

    public Constraint like() {
        throw new QueryEngineException();
    }

    public Constraint contains() {
        throw new QueryEngineException();
    }

    public Constraint not() {
        throw new QueryEngineException();
    }

    public Object getObject() {
        throw new QueryEngineException();
    }

    public boolean execute(Session session, FielComparator comparator, Object candidate) {
        return false;
    }

    protected void addBinaryConstraint(BinaryBooleanOperatorConstraint binaryConstraint) {
        if (!fathers.contains(binaryConstraint)) {
            fathers.add(binaryConstraint);
        }
    }

    public Set getRootFathers() {
        HashSet result = new HashSet();
        if (!fathers.isEmpty()) {
            Iterator bcIt = fathers.iterator();
            while (bcIt.hasNext()) {
                BinaryBooleanOperatorConstraint bc = (BinaryBooleanOperatorConstraint) bcIt.next();
                result.addAll(bc.getRootFathers());
            }
        } else {
            result.add(this);
        }
        return result;
    }


    protected Set fathers;
}
