/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.se.query.result;

import org.objectweb.jalisto.se.api.Session;
import org.objectweb.jalisto.se.api.query.ObjectSet;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

public class ObjectSetImpl implements ObjectSet {

    public ObjectSetImpl(Collection results) {
        this.list = new ArrayList(results);
        this.index = 0;
    }

    public boolean hasNext() {
        return (list.size() > index);
    }

    public Object next() {
        return list.get(index++);
    }

    public void reset() {
        index = 0;
    }

    public int size() {
        return list.size();
    }

    public int getIndex() {
        return index;
    }

    public void incrIndex() {
        index++;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public void sort() {
        Collections.sort(list);
    }

    public String toString() {
        return String.valueOf(list);
    }

    public String toStringFull(Session session) {
        StringBuffer sb = new StringBuffer();
        sb.append("(");
        for (int i = 0; i < list.size(); i++) {
            QueryResultWrapper r = (QueryResultWrapper) list.get(i);
            sb.append(r.toStringFull(session));
            if (i < list.size() - 1) {
                sb.append(",");
            }
        }
        sb.append(")");
        return sb.toString();
    }

    private ArrayList list;
    private int index;
}
