/*
 * Jalisto - JAva LIght STOrage
 * Copyright (C) 2000-2005 Xcalia http://www.xcalia.com
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Xcalia
 * 71, rue Desnouettes
 * 75014 Paris - France
 * http://www.xcalia.com
 */
package org.objectweb.jalisto.samples.basic2.data;

import java.util.Random;

public class Book {
    private Book() {
    }

    private Book(String title, int pages) {
        this.pages = pages;
        this.title = title;
    }

    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    public int getPages() {
        return pages;
    }

    public void setPages(int pages) {
        this.pages = pages;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append("'").append(title).append(", ").append(pages).append(" pages");
        if (comments != null) {
            result.append(", ").append(comments);
        }
        result.append("'");
        return result.toString();
    }


    private String title;
    private int pages;
    private String comments;


    /**
     * *****************  CONSTRUCTION STATIC METHODS   *********************
     */

    public static Book newBook() {
        return new Book(getNewTitle(), getNewPages());
    }

    private static String getNewTitle() {
        return titles[random.nextInt(titles.length)];
    }

    public static int getNewPages() {
        return random.nextInt(1000);
    }

    /**
     * ****************** UTILITY METHODS *********************
     */

    public static Book toBook(Object[] array) {
        Book book = new Book();
        book.setTitle((String) array[0]);
        book.setPages(((Integer) array[1]).intValue());
        book.setComments((String) array[2]);
        return book;
    }

    public Object[] toArray() {
        Object[] result = new Object[3];
        result[0] = title;
        result[1] = new Integer(pages);
        result[2] = comments;
        return result;
    }

    private static Random random = new Random();
    private static String[] fieldNames = {"title", "pages", "comments"};
    private static String titles[] = {"Death Off Stage",
                                      "At the Edge",
                                      "Fingersmith",
                                      "Metes and Bounds",
                                      "A Fountain Filled with Blood",
                                      "A Cold Case of Murder",
                                      "Innocent Hearts",
                                      "Tipping the Velvet",
                                      "Bittersweet",
                                      "The Jester",
                                      "2nd Chance",
                                      "Beyond All Reason"};
}
